MyGUI: MyGUI::PopupMenu Class Reference

MyGUI 3.4.3

Public Types | Public Member Functions | Static Public Member Functions
MyGUI::PopupMenu Class Reference

widget description should be here. More...

`#include <MyGUI_PopupMenu.h>`

Inheritance diagram for MyGUI::PopupMenu:
[legend]

## Public Types
typedef RTTIBase | Base
typedef PopupMenu | RTTIBase
Public Types inherited from MyGUI::MenuControl
typedef RTTIBase | Base
typedef MenuControl | RTTIBase
using | VectorMenuItemInfo = std::vector<ItemInfo>
Public Types inherited from MyGUI::Widget
typedef RTTIBase | Base
typedef Widget | RTTIBase
Public Types inherited from MyGUI::IObject
typedef IObject | RTTIBase

## Public Member Functions
virtual std::string_view | getTypeName () const override
virtual bool | isType (const std::type_info &_type) const override
template<typename Type>
bool | isType () const
| PopupMenu ()
Public Member Functions inherited from MyGUI::MenuControl
template<typename Type>
bool | isType () const
void | setVisible (bool _visible) override
void | setVisibleSmooth (bool _visible)
size_t | getItemCount () const
| Get number of items.
MenuItem * | insertItemAt (size_t _index, const UString &_name, MenuItemType _type=MenuItemType::Normal, std::string_view _id={}, Any _data=Any::Null)
| Insert an item into a array at a specified position.
MenuItem * | insertItem (MenuItem *_to, const UString &_name, MenuItemType _type=MenuItemType::Normal, std::string_view _id={}, Any _data=Any::Null)
| Insert an item into a array.
MenuItem * | addItem (const UString &_name, MenuItemType _type=MenuItemType::Normal, std::string_view _id={}, Any _data=Any::Null)
| Add an item to the end of a array.
void | removeItemAt (size_t _index)
| Remove item at a specified position.
void | removeItem (MenuItem *_item)
| Remove item.
void | removeAllItems ()
| Remove all items.
MenuItem * | getItemAt (size_t _index) const
| Get item from specified position.
size_t | getItemIndex (const MenuItem *_item) const
| Get item index.
size_t | findItemIndex (MenuItem *_item)
| Search item, returns the position of the first occurrence in array or ITEM_NONE if item not found.
MenuItem * | findItemWith (const UString &_name)
| Search item, returns the item of the first occurrence in array or nullptr if item not found.
void | setItemDataAt (size_t _index, Any _data)
| Replace an item data at a specified position.
void | setItemData (MenuItem *_item, Any _data)
| Replace an item data.
void | clearItemDataAt (size_t _index)
| Clear an item data at a specified position.
void | clearItemData (MenuItem *_item)
| Clear an item data.
template<typename ValueType>
ValueType * | getItemDataAt (size_t _index, bool _throw=true)
| Get item data from specified position.
template<typename ValueType>
ValueType * | getItemData (MenuItem *_item, bool _throw=true)
| Get item data.
void | setItemIdAt (size_t _index, std::string_view _id)
| Replace an item id at a specified position.
void | setItemId (MenuItem *_item, std::string_view _id)
| Replace an item id.
const std::string & | getItemIdAt (size_t _index) const
| Get item id from specified position.
const std::string & | getItemId (const MenuItem *_item) const
| Get item id.
MenuItem * | getItemById (std::string_view _id) const
MenuItem * | findItemById (std::string_view _id, bool _recursive=false)
size_t | getItemIndexById (std::string_view _id) const
void | setItemNameAt (size_t _index, const UString &_name)
| Replace an item name at a specified position.
void | setItemName (MenuItem *_item, const UString &_name)
| Replace an item name.
const UString & | getItemNameAt (size_t _index) const
| Get item from specified position.
const UString & | getItemName (const MenuItem *_item) const
| Get item from specified position.
size_t | findItemIndexWith (const UString &_name)
| Search item, returns the position of the first occurrence in array or ITEM_NONE if item not found.
void | setItemChildVisibleAt (size_t _index, bool _visible)
void | setItemChildVisible (MenuItem *_item, bool _visible)
template<typename Type>
Type * | createItemChildTAt (size_t _index)
template<typename Type>
Type * | createItemChildT (MenuItem *_item)
MenuControl * | getItemChildAt (size_t _index) const
MenuControl * | getItemChild (const MenuItem *_item) const
MenuControl * | createItemChildAt (size_t _index)
MenuControl * | createItemChild (MenuItem *_item)
void | removeItemChildAt (size_t _index)
void | removeItemChild (MenuItem *_item)
MenuItemType | getItemTypeAt (size_t _index) const
MenuItemType | getItemType (const MenuItem *_item) const
void | setItemTypeAt (size_t _index, MenuItemType _type)
void | setItemType (MenuItem *_item, MenuItemType _type)
void | setPopupAccept (bool _value)
bool | getPopupAccept () const
MenuItem * | getMenuItemParent () const
void | setVerticalAlignment (bool _value)
bool | getVerticalAlignment () const
void | _notifyDeleteItem (MenuItem *_item)
void | _notifyDeletePopup (MenuItem *_item)
void | _notifyUpdateName (MenuItem *_item)
void | _wrapItemChild (MenuItem *_item, MenuControl *_widget)
size_t | _getItemCount () const override
void | _addItem (const MyGUI::UString &_name) override
void | _removeItemAt (size_t _index) override
Widget * | _getItemAt (size_t _index) const override
void | _setItemNameAt (size_t _index, const UString &_name) override
const UString & | _getItemNameAt (size_t _index) const override
void | _setItemSelected (IItem *_item) override
void | _updateItems (size_t _index)
void | _updateSizeForEmpty ()
Public Member Functions inherited from MyGUI::Widget
template<typename Type>
bool | isType () const
Widget * | createWidgetT (std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _name={})
Widget * | createWidgetT (std::string_view _type, std::string_view _skin, int _left, int _top, int _width, int _height, Align _align, std::string_view _name={})
Widget * | createWidgetRealT (std::string_view _type, std::string_view _skin, const FloatCoord &_coord, Align _align, std::string_view _name={})
Widget * | createWidgetRealT (std::string_view _type, std::string_view _skin, float _left, float _top, float _width, float _height, Align _align, std::string_view _name={})
template<typename T>
T * | createWidget (std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _name={})
template<typename T>
T * | createWidget (std::string_view _skin, int _left, int _top, int _width, int _height, Align _align, std::string_view _name={})
template<typename T>
T * | createWidgetReal (std::string_view _skin, const FloatCoord &_coord, Align _align, std::string_view _name={})
template<typename T>
T * | createWidgetReal (std::string_view _skin, float _left, float _top, float _width, float _height, Align _align, std::string_view _name={})
Widget * | createWidgetT (WidgetStyle _style, std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer={}, std::string_view _name={})
template<typename T>
T * | createWidget (WidgetStyle _style, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer={}, std::string_view _name={})
void | setPosition (const IntPoint &_point) override
void | setSize (const IntSize &_size) override
void | setCoord (const IntCoord &_coord) override
void | setPosition (int _left, int _top)
void | setSize (int _width, int _height)
void | setCoord (int _left, int _top, int _width, int _height)
void | setRealPosition (const FloatPoint &_point)
void | setRealSize (const FloatSize &_size)
void | setRealCoord (const FloatCoord &_coord)
void | setRealPosition (float _left, float _top)
void | setRealSize (float _width, float _height)
void | setRealCoord (float _left, float _top, float _width, float _height)
const std::string & | getName () const
| Get name of widget.
bool | getVisible () const
void | setDepth (int _value)
int | getDepth () const
bool | getInheritedVisible () const
virtual void | setAlign (Align _value)
Align | getAlign () const
void | setAlpha (float _alpha)
float | getAlpha () const
void | setInheritsAlpha (bool _inherits)
bool | getInheritsAlpha () const
void | setColour (const Colour &_value)
bool | isRootWidget () const
Widget * | getParent () const
IntSize | getParentSize () const
EnumeratorWidgetPtr | getEnumerator () const
size_t | getChildCount () const
Widget * | getChildAt (size_t _index) const
Widget * | findWidget (std::string_view _name)
void | findWidgets (std::string_view _name, VectorWidgetPtr &_result)
virtual void | setEnabled (bool _value)
void | setEnabledSilent (bool _value)
bool | getEnabled () const
bool | getInheritedEnabled () const
IntCoord | getClientCoord () const
Widget * | getClientWidget ()
const Widget * | getClientWidget () const
void | detachFromWidget (std::string_view _layer={})
void | attachToWidget (Widget *_parent, WidgetStyle _style=WidgetStyle::Child, std::string_view _layer={})
void | changeWidgetSkin (std::string_view _skinName)
void | setWidgetStyle (WidgetStyle _style, std::string_view _layer={})
WidgetStyle | getWidgetStyle () const
void | setProperty (std::string_view _key, std::string_view _value)
virtual size_t | _getItemIndex (Widget *_item) const
void | _forcePick (Widget *_widget)
void | _initialise (WidgetStyle _style, const IntCoord &_coord, std::string_view _skinName, Widget *_parent, ICroppedRectangle *_croppedParent, std::string_view _name)
void | _shutdown ()
void | _destroyChildWidget (Widget *_widget)
void | _setContainer (Widget *_value)
Widget * | _getContainer () const
void | _setAlign (const IntSize &_oldsize, const IntSize &_newSize)
bool | _checkPoint (int _left, int _top) const
Widget * | _createSkinWidget (WidgetStyle _style, std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer={}, std::string_view _name={})
virtual void | _resetContainer (bool _update)
bool | _setWidgetState (std::string_view _state)
void | _updateChilds ()
Public Member Functions inherited from MyGUI::IObject
template<typename Type>
bool | isType () const
template<typename Type>
Type * | castType (bool _throw=true)
template<typename Type>
const Type * | castType (bool _throw=true) const
virtual | ~IObject ()=default
Public Member Functions inherited from MyGUI::ICroppedRectangle
virtual | ~ICroppedRectangle ()=default
ICroppedRectangle * | getCroppedParent ()
IntPoint | getPosition () const
IntSize | getSize () const
const IntCoord & | getCoord () const
const IntPoint & | getAbsolutePosition () const
IntRect | getAbsoluteRect () const
IntCoord | getAbsoluteCoord () const
int | getAbsoluteLeft () const
int | getAbsoluteTop () const
int | getLeft () const
int | getRight () const
int | getTop () const
int | getBottom () const
int | getWidth () const
int | getHeight () const
bool | _isMargin () const
int | _getViewLeft () const
int | _getViewRight () const
int | _getViewTop () const
int | _getViewBottom () const
int | _getViewWidth () const
int | _getViewHeight () const
void | _setCroppedParent (ICroppedRectangle *_parent)
const IntRect & | _getMargin () const
int | _getMarginLeft () const
int | _getMarginRight () const
int | _getMarginTop () const
int | _getMarginBottom () const
Public Member Functions inherited from MyGUI::UserData
virtual | ~UserData ()=default
void | setUserString (std::string_view _key, std::string_view _value)
std::string_view | getUserString (std::string_view _key) const
const MapString & | getUserStrings () const
bool | clearUserString (std::string_view _key)
bool | isUserString (std::string_view _key) const
void | clearUserStrings ()
void | setUserData (Any _data)
template<typename ValueType>
ValueType * | getUserData (bool _throw=true) const
void | _setInternalData (Any _data)
template<typename ValueType>
ValueType * | _getInternalData (bool _throw=true) const
Public Member Functions inherited from MyGUI::WidgetInput
virtual | ~WidgetInput ()=default
void | setNeedToolTip (bool _value)
bool | getNeedToolTip () const
void | setPointer (std::string_view _value)
const std::string & | getPointer () const
void | setNeedKeyFocus (bool _value)
bool | getNeedKeyFocus () const
void | setNeedMouseFocus (bool _value)
bool | getNeedMouseFocus () const
void | setInheritsPick (bool _value)
bool | getInheritsPick () const
void | setMaskPick (const std::string &_filename)
void | setMaskPick (const MaskPickInfo &_info)
bool | isMaskPickInside (const IntPoint &_point, const IntCoord &_coord) const
bool | getRootMouseFocus () const
bool | getRootKeyFocus () const
void | _riseMouseLostFocus (Widget *_new)
void | _riseMouseSetFocus (Widget *_old)
void | _riseMouseDrag (int _left, int _top, MouseButton _id)
void | _riseMouseMove (int _left, int _top)
void | _riseMouseWheel (int _rel)
void | _riseMouseButtonPressed (int _left, int _top, MouseButton _id)
void | _riseMouseButtonReleased (int _left, int _top, MouseButton _id)
void | _riseMouseButtonClick ()
void | _riseMouseButtonDoubleClick ()
void | _riseKeyLostFocus (Widget *_new)
void | _riseKeySetFocus (Widget *_old)
void | _riseKeyButtonPressed (KeyCode _key, Char _char)
void | _riseKeyButtonReleased (KeyCode _key)
void | _riseMouseChangeRootFocus (bool _focus)
void | _riseKeyChangeRootFocus (bool _focus)
void | _setRootMouseFocus (bool _value)
void | _setRootKeyFocus (bool _value)
Public Member Functions inherited from MyGUI::delegates::IDelegateUnlink
virtual | ~IDelegateUnlink ()=default
| IDelegateUnlink ()
bool | compare (IDelegateUnlink *_unlink) const
Public Member Functions inherited from MyGUI::SkinItem
ISubWidgetText * | getSubWidgetText () const
ISubWidgetRect * | getSubWidgetMain () const
void | _setTextureName (std::string_view _texture)
const std::string & | _getTextureName () const
Public Member Functions inherited from MyGUI::LayerItem
ILayer * | getLayer () const
ILayerNode * | getLayerNode () const
void | attachItemToNode (ILayer *_layer, ILayerNode *_node) override
void | detachFromLayer () override
void | upLayerItem () override
void | setRenderItemTexture (ITexture *_texture)
void | addChildItem (LayerItem *_item)
void | removeChildItem (LayerItem *_item)
void | addChildNode (LayerItem *_item)
void | removeChildNode (LayerItem *_item)
void | addRenderItem (ISubWidget *_item)
void | removeAllRenderItems ()
void | saveLayerItem ()
void | restoreLayerItem ()
Public Member Functions inherited from MyGUI::ILayerItem
virtual | ~ILayerItem ()=default
Public Member Functions inherited from MyGUI::MemberObsolete< Widget >
bool | isEnabled ()
bool | isInheritsAlpha ()
bool | isNeedKeyFocus ()
bool | isNeedMouseFocus ()
bool | isInheritsPick ()
bool | isVisible ()
Public Member Functions inherited from MyGUI::IItemContainer
virtual | ~IItemContainer ()=default
Public Member Functions inherited from MyGUI::MemberObsolete< MenuControl >
void | showMenu ()
void | hideMenu ()
bool | isShowMenu ()
void | showItemChildAt (size_t _index)
void | showItemChild (MenuItem *_item)
void | hideItemChildAt (size_t _index)
void | hideItemChild (MenuItem *_item)
void | setAlignVert (bool _value)
bool | getAlignVert () const

## Static Public Member Functions
static std::string_view | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::MenuControl
static std::string_view | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::Widget
static std::string_view | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::IObject
static std::string_view | getClassTypeName ()

## Additional Inherited Members
Data Fields inherited from MyGUI::MenuControl
EventHandle_MenuCtrlPtrMenuItemPtr | eventMenuCtrlAccept
EventHandle_MenuCtrlPtr | eventMenuCtrlClose
Data Fields inherited from MyGUI::Widget
EventHandle_WidgetStringString | eventChangeProperty
EventHandle_WidgetVoid | eventChangeCoord
EventHandle_WidgetVoid | eventWidgetDestroyed
Data Fields inherited from MyGUI::WidgetInput
EventHandle_WidgetWidget | eventMouseLostFocus
EventHandle_WidgetWidget | eventMouseSetFocus
EventPairAddParameter< EventHandle_WidgetIntInt, EventHandle_WidgetIntIntButton > | eventMouseDrag
EventHandle_WidgetIntInt | eventMouseMove
EventHandle_WidgetInt | eventMouseWheel
EventHandle_WidgetIntIntButton | eventMouseButtonPressed
EventHandle_WidgetIntIntButton | eventMouseButtonReleased
EventHandle_WidgetVoid | eventMouseButtonClick
EventHandle_WidgetVoid | eventMouseButtonDoubleClick
EventHandle_WidgetWidget | eventKeyLostFocus
EventHandle_WidgetWidget | eventKeySetFocus
EventHandle_WidgetKeyCodeChar | eventKeyButtonPressed
EventHandle_WidgetKeyCode | eventKeyButtonReleased
EventHandle_WidgetBool | eventRootMouseChangeFocus
EventHandle_WidgetBool | eventRootKeyChangeFocus
EventHandle_WidgetToolTip | eventToolTip
Protected Member Functions inherited from MyGUI::MenuControl
void | initialiseOverride () override
void | shutdownOverride () override
void | onKeyChangeRootFocus (bool _focus) override
void | onWidgetCreated (Widget *_widget) override
void | setPropertyOverride (std::string_view _key, std::string_view _value) override
Protected Member Functions inherited from MyGUI::Widget
| ~Widget () override=default
void | _updateView ()
Widget * | baseCreateWidget (WidgetStyle _style, std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer, std::string_view _name, bool _template)
void | _destroyAllChildWidget ()
virtual size_t | _getContainerIndex (const IntPoint &_point) const
virtual void | baseUpdateEnable ()
ILayerItem * | getLayerItemByPoint (int _left, int _top) const override
const IntCoord & | getLayerItemCoord () const override
template<typename T>
void | assignWidget (T *&_widget, std::string_view _name)
VectorWidgetPtr | getSkinWidgetsByName (std::string_view _name) const
virtual void | onWidgetDestroy (Widget *_widget)
void | setWidgetClient (Widget *_widget)
Widget * | _getClientWidget ()
| If there is client widget return it, otherwise return this.
const Widget * | _getClientWidget () const
Protected Member Functions inherited from MyGUI::ICroppedRectangle
bool | _checkMargin ()
bool | _checkOutside () const
Protected Member Functions inherited from MyGUI::WidgetInput
virtual void | onMouseLostFocus (Widget *_new)
virtual void | onMouseSetFocus (Widget *_old)
virtual void | onMouseDrag (int _left, int _top, MouseButton _id)
virtual void | onMouseMove (int _left, int _top)
virtual void | onMouseWheel (int _rel)
virtual void | onMouseButtonPressed (int _left, int _top, MouseButton _id)
virtual void | onMouseButtonReleased (int _left, int _top, MouseButton _id)
virtual void | onMouseButtonClick ()
virtual void | onMouseButtonDoubleClick ()
virtual void | onKeyLostFocus (Widget *_new)
virtual void | onKeySetFocus (Widget *_old)
virtual void | onKeyButtonPressed (KeyCode _key, Char _char)
virtual void | onKeyButtonReleased (KeyCode _key)
virtual void | onMouseChangeRootFocus (bool _focus)
Protected Member Functions inherited from MyGUI::SkinItem
void | _createSkinItem (ResourceSkin *_info)
void | _deleteSkinItem ()
void | _setSkinItemAlign (const IntSize &_size)
void | _setSkinItemVisible (bool _value)
void | _setSkinItemColour (const Colour &_value)
void | _setSkinItemAlpha (float _value)
void | _correctSkinItemView ()
void | _updateSkinItemView ()
bool | _setSkinItemState (std::string_view _state)
void | _setSubSkinVisible (bool _visible)
Protected Member Functions inherited from MyGUI::LayerItem
void | attachToLayerItemNode (ILayerNode *_item, bool _deep)
void | detachFromLayerItemNode (bool _deep)
Protected Attributes inherited from MyGUI::MenuControl
bool | mHideByAccept {true}
bool | mMenuDropMode {false}
bool | mIsMenuDrop {true}
bool | mHideByLostKey {false}
bool | mResizeToContent {true}
Protected Attributes inherited from MyGUI::ICroppedRectangle
IntRect | mMargin
IntCoord | mCoord
IntPoint | mAbsolutePosition
bool | mIsMargin {false}
ICroppedRectangle * | mCroppedParent {nullptr}

## Detailed Description

widget description should be here.

Definition at line 19 of file MyGUI_PopupMenu.h.

## Member Typedef Documentation

## ◆ Base

typedef RTTIBase MyGUI::PopupMenu::Base

Definition at line 21 of file MyGUI_PopupMenu.h.

## ◆ RTTIBase

typedef PopupMenu MyGUI::PopupMenu::RTTIBase

Definition at line 21 of file MyGUI_PopupMenu.h.

## Constructor & Destructor Documentation

## ◆ PopupMenu()

MyGUI::PopupMenu::PopupMenu | ( |  | ) |

Definition at line 13 of file MyGUI_PopupMenu.cpp.

## Member Function Documentation

## ◆ getClassTypeName()

std::string_view MyGUI::PopupMenu::getClassTypeName | ( |  | ) |
| inlinestatic

Definition at line 21 of file MyGUI_PopupMenu.h.

## ◆ getTypeName()

virtual std::string_view MyGUI::PopupMenu::getTypeName | ( |  | ) | const
| inlineoverridevirtual

Get type name as string

Reimplemented from MyGUI::MenuControl.

Definition at line 21 of file MyGUI_PopupMenu.h.

## ◆ isType() [1/2]

template<typename Type>

bool MyGUI::PopupMenu::isType | ( |  | ) | const
| inline

Compare with selected type

Definition at line 21 of file MyGUI_PopupMenu.h.

## ◆ isType() [2/2]

virtual bool MyGUI::PopupMenu::isType | ( | const std::type_info & | _type | ) | const
| inlineoverridevirtual

Compare with selected type

Reimplemented from MyGUI::MenuControl.

Definition at line 21 of file MyGUI_PopupMenu.h.

The documentation for this class was generated from the following files:

- MyGUI_PopupMenu.h
- MyGUI_PopupMenu.cpp